import { Outpoint } from './type/wallet-types';
export * from 'common-ts/index.js';
/** Blockchain functions */
export declare function GetBlockCount(): any;
export declare function GetFilterCount(): any;
export declare function GetFilterHeaderCount(): any;
export declare function GetBlockHeader(sha256hash: string): any;
export declare function GetInfo(): any;
/** Network message functions */
export declare function GetPeers(): any;
export declare function Stop(): any;
/** Specific Server message functions */
export declare function IsEmpty(): any;
export declare function WalletInfo(): any;
export declare function GetBalance(inSats: boolean): any;
export declare function GetConfirmedBalance(inSats: boolean): any;
export declare function GetUnconfirmedBalance(inSats: boolean): any;
export declare function GetBalances(inSats: boolean): any;
export declare function GetNewAddress(label?: string): any;
export declare function GetTransaction(sha256hash: string): any;
export declare function LockUnspent(unlock: boolean, outPoints: any[]): any;
export declare function LabelAddress(address: string, label: string): any;
export declare function DropAddressLabel(address: string, label: string): any;
export declare function GetAddressLabels(): any;
export declare function DropAddressLabels(address: string): any;
/** DLC Message Functions */
export declare function GetDLCHostAddress(): any;
export declare function CreateContractInfo(announcementTLV: string, totalCollateral: number, payoutsVal: any): any;
export declare function GetDLCs(contactAddress?: string): any;
export declare function GetDLC(sha256hash: string): any;
export declare function CancelDLC(sha256hash: string): any;
export declare function CreateDLCOffer(contractInfoTLV: string, collateral: number, feeRate: number, locktime: number, refundLT: number): any;
export declare function GetDLCOffer(temporaryContractId: string): any;
export declare function AcceptDLCOffer(offerHex: string): any;
export declare function AcceptDLCOfferFromFile(path: string, destination?: string): any;
export declare function SignDLC(acceptHex: string): any;
export declare function SignDLCFromFile(path: string, destination?: string): any;
export declare function AddDLCSigs(sigsHex: string): any;
export declare function AddDLCSigsFromFile(path: string, destination?: string): any;
export declare function AddDLCSigsAndBroadcast(sigsHex: string): any;
export declare function AddDLCSigsAndBroadcastFromFile(path: string, destination?: string): any;
export declare function GetDLCFundingTx(contractIdHex: string): any;
export declare function BroadcastDLCFundingTx(contractIdHex: string): any;
export declare function ExecuteDLC(contractIdHex: string, oracleSigs: string[], noBroadcast: boolean): any;
export declare function ExecuteDLCRefund(contractIdHex: string, noBroadcast: boolean): any;
export declare function SendToAddress(address: string, bitcoins: number, satsPerVByte: number, noBroadcast: boolean): any;
export declare function SendFromOutpoints(outPoints: Outpoint[], bitcoins: number, satsPerVByte: number): any;
export declare function SweepWallet(address: string, satsPerVByte: number): any;
export declare function SendWithAlgo(address: string, bitcoins: number, satsPerVByte: number, algo: string): any;
export declare function SignPSBT(hexOrBase64: string): any;
export declare function OpReturnCommit(message: string, hashMessage: boolean, satsPerVByte: number): any;
export declare function BumpFeeRBF(sha256hash: string, satsPerVByte: number): any;
export declare function BumpFeeCPFP(sha256hash: string, satsPerVByte: number): any;
export declare function Rescan(batchSize: number | null, start: number | null, end: number | null, force: boolean, ignoreCreationTime: boolean): any;
export declare function GetUTXOs(): any;
export declare function ListReservedUTXOs(): any;
export declare function GetAddresses(): any;
export declare function GetSpentAddresses(): any;
export declare function GetFundedAddresses(): any;
export declare function GetUnusedAddresses(): any;
export declare function GetAccounts(): any;
export declare function GetAddressInfo(address: string): any;
export declare function CreateNewAccount(): any;
export declare function ImportSeed(walletName: string, mnemonic: string, passphrase?: string): any;
export declare function ImportXprv(walletName: string, mnemonic: string, passphrase?: string): any;
export declare function SendRawTransaction(hex: string): any;
export declare function EstimateFee(): any;
export declare function GetDLCWalletAccounting(): any;
export declare function BackupWallet(path: string): any;
/** Core Route Functions */
export declare function FinalizePSBT(): any;
export declare function ExtractFromPSBT(): any;
export declare function ConvertToPSBT(): any;
export declare function CombinePSBT(): any;
export declare function JoinPSBTs(): any;
export declare function DecodePSBT(): any;
export declare function DecodeRawTransaction(): any;
export declare function AnalyzePSBT(): any;
export declare function DecodeSign(signedHex: string): any;
export declare function DecodeAccept(acceptHex: string): any;
export declare function DecodeOffer(offerHex: string): any;
export declare function DecodeContractInfo(contractInfoHex: string): any;
export declare function DecodeAnnouncement(announcementHex: string): any;
export declare function DecodeAttestments(attestmentHex: string): any;
export declare function CreateMultiSig(): any;
/** Offers */
export declare function OfferList(): any;
export declare function OfferAdd(offerTLV: string, peer: string, message: string): any;
export declare function OfferRemove(hash: string): any;
/** Contacts */
export declare function ContactList(): any;
export declare function ContactAdd(alias: string, address: string, memo: string): any;
export declare function ContactRemove(address: string): any;
export declare function DLCContactAdd(dlcId: string, address: string): any;
export declare function DLCContactRemove(dlcId: string): any;
//# sourceMappingURL=index.d.ts.map