"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __exportStar = (this && this.__exportStar) || function(m, exports) {
    for (var p in m) if (p !== "default" && !Object.prototype.hasOwnProperty.call(exports, p)) __createBinding(exports, m, p);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ListReservedUTXOs = exports.GetUTXOs = exports.Rescan = exports.BumpFeeCPFP = exports.BumpFeeRBF = exports.OpReturnCommit = exports.SignPSBT = exports.SendWithAlgo = exports.SweepWallet = exports.SendFromOutpoints = exports.SendToAddress = exports.ExecuteDLCRefund = exports.ExecuteDLC = exports.BroadcastDLCFundingTx = exports.GetDLCFundingTx = exports.AddDLCSigsAndBroadcastFromFile = exports.AddDLCSigsAndBroadcast = exports.AddDLCSigsFromFile = exports.AddDLCSigs = exports.SignDLCFromFile = exports.SignDLC = exports.AcceptDLCOfferFromFile = exports.AcceptDLCOffer = exports.GetDLCOffer = exports.CreateDLCOffer = exports.CancelDLC = exports.GetDLC = exports.GetDLCs = exports.CreateContractInfo = exports.GetDLCHostAddress = exports.DropAddressLabels = exports.GetAddressLabels = exports.DropAddressLabel = exports.LabelAddress = exports.LockUnspent = exports.GetTransaction = exports.GetNewAddress = exports.GetBalances = exports.GetUnconfirmedBalance = exports.GetConfirmedBalance = exports.GetBalance = exports.WalletInfo = exports.IsEmpty = exports.Stop = exports.GetPeers = exports.GetInfo = exports.GetBlockHeader = exports.GetFilterHeaderCount = exports.GetFilterCount = exports.GetBlockCount = void 0;
exports.DLCContactRemove = exports.DLCContactAdd = exports.ContactRemove = exports.ContactAdd = exports.ContactList = exports.OfferRemove = exports.OfferAdd = exports.OfferList = exports.CreateMultiSig = exports.DecodeAttestments = exports.DecodeAnnouncement = exports.DecodeContractInfo = exports.DecodeOffer = exports.DecodeAccept = exports.DecodeSign = exports.AnalyzePSBT = exports.DecodeRawTransaction = exports.DecodePSBT = exports.JoinPSBTs = exports.CombinePSBT = exports.ConvertToPSBT = exports.ExtractFromPSBT = exports.FinalizePSBT = exports.BackupWallet = exports.GetDLCWalletAccounting = exports.EstimateFee = exports.SendRawTransaction = exports.ImportXprv = exports.ImportSeed = exports.CreateNewAccount = exports.GetAddressInfo = exports.GetAccounts = exports.GetUnusedAddresses = exports.GetFundedAddresses = exports.GetSpentAddresses = exports.GetAddresses = void 0;
const index_js_1 = require("common-ts/index.js");
const message_util_js_1 = require("common-ts/util/message-util.js");
const validation_util_js_1 = require("common-ts/util/validation-util.js");
// Expose all 'common' endpoints
__exportStar(require("common-ts/index.js"), exports);
/** Blockchain functions */
function GetBlockCount() {
    console.debug('GetBlockCount()');
    const m = (0, message_util_js_1.getMessageBody)("getblockcount" /* getblockcount */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetBlockCount = GetBlockCount;
function GetFilterCount() {
    console.debug('GetFilterCount()');
    const m = (0, message_util_js_1.getMessageBody)("getfiltercount" /* getfiltercount */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetFilterCount = GetFilterCount;
function GetFilterHeaderCount() {
    console.debug('GetFilterHeaderCount()');
    const m = (0, message_util_js_1.getMessageBody)("getfilterheadercount" /* getfilterheadercount */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetFilterHeaderCount = GetFilterHeaderCount;
// returns "failure" for not found, needs error wrapped
function GetBlockHeader(sha256hash) {
    console.debug('GetBlockHeader()', sha256hash);
    (0, validation_util_js_1.validateString)(sha256hash, 'GetBlockHeader()', 'sha256hash');
    const m = (0, message_util_js_1.getMessageBody)("getblockheader" /* getblockheader */, [sha256hash]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetBlockHeader = GetBlockHeader;
function GetInfo() {
    console.debug('GetInfo()');
    const m = (0, message_util_js_1.getMessageBody)("getinfo" /* getinfo */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetInfo = GetInfo;
/** Network message functions */
function GetPeers() {
    console.debug('GetPeers()');
    const m = (0, message_util_js_1.getMessageBody)("getpeers" /* getpeers */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Current response: 'TODO implement getpeers'
        return response;
    });
}
exports.GetPeers = GetPeers;
function Stop() {
    console.debug('Stop()');
    const m = (0, message_util_js_1.getMessageBody)("stop" /* stop */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Current response: 'Node shutting down'
        return response;
    });
}
exports.Stop = Stop;
// export function DecodeRawTransaction() {
//   console.debug('GetFilterHeaderCount()')
//   const m = getMessageBody(BlockchainMessageType.decoderawtransaction)
//   return SendOracleMessage(m).then(response => {
//     return <ServerResponse<VersionResponse>>response
//   })
// }
/** Specific Server message functions */
function IsEmpty() {
    console.debug('IsEmpty()');
    const m = (0, message_util_js_1.getMessageBody)("isempty" /* isempty */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.IsEmpty = IsEmpty;
function WalletInfo() {
    console.debug('WalletInfo()');
    const m = (0, message_util_js_1.getMessageBody)("walletinfo" /* walletinfo */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.WalletInfo = WalletInfo;
// Do we want this to just return a number vs string with label?
function GetBalance(inSats) {
    console.debug('GetBalance()', inSats);
    (0, validation_util_js_1.validateBoolean)(inSats, 'GetBalance()', 'inSats');
    const m = (0, message_util_js_1.getMessageBody)("getbalance" /* getbalance */, [inSats]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // This comes with ' sats' or ' BTC' label
        return response;
    });
}
exports.GetBalance = GetBalance;
// Do we want this to just return a number vs string with label?
function GetConfirmedBalance(inSats) {
    console.debug('GetConfirmedBalance()', inSats);
    (0, validation_util_js_1.validateBoolean)(inSats, 'GetConfirmedBalance()', 'inSats');
    const m = (0, message_util_js_1.getMessageBody)("getconfirmedbalance" /* getconfirmedbalance */, [inSats]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // This comes with ' sats' or ' BTC' label
        return response;
    });
}
exports.GetConfirmedBalance = GetConfirmedBalance;
// Do we want this to just return a number vs string with label?
function GetUnconfirmedBalance(inSats) {
    console.debug('GetUnconfirmedBalance()', inSats);
    (0, validation_util_js_1.validateBoolean)(inSats, 'GetUnconfirmedBalance()', 'inSats');
    const m = (0, message_util_js_1.getMessageBody)("getunconfirmedbalance" /* getunconfirmedbalance */, [inSats]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // This comes with ' sats' or ' BTC' label
        return response;
    });
}
exports.GetUnconfirmedBalance = GetUnconfirmedBalance;
function GetBalances(inSats) {
    console.debug('GetBalances()', inSats);
    (0, validation_util_js_1.validateBoolean)(inSats, 'GetBalances()', 'inSats');
    const m = (0, message_util_js_1.getMessageBody)("getbalances" /* getbalances */, [inSats]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // This comes with ' sats' or ' BTC' label
        return response;
    });
}
exports.GetBalances = GetBalances;
// Should it be possible to create a new address without a label?
function GetNewAddress(label) {
    console.debug('GetNewAddress()', label);
    if (label !== undefined) {
        (0, validation_util_js_1.validateString)(label, 'GetNewAddress()', 'label');
        const m = (0, message_util_js_1.getMessageBody)("getnewaddress" /* getnewaddress */, [label]);
        return (0, index_js_1.SendServerMessage)(m).then(response => {
            return response;
        });
    }
    else {
        const m = (0, message_util_js_1.getMessageBody)("getnewaddress" /* getnewaddress */);
        return (0, index_js_1.SendServerMessage)(m).then(response => {
            return response;
        });
    }
}
exports.GetNewAddress = GetNewAddress;
function GetTransaction(sha256hash) {
    console.debug('GetTransaction()', sha256hash);
    (0, validation_util_js_1.validateString)(sha256hash, 'GetTransaction()', 'sha256hash');
    const m = (0, message_util_js_1.getMessageBody)("gettransaction" /* gettransaction */, [sha256hash]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetTransaction = GetTransaction;
function LockUnspent(unlock, outPoints) {
    console.debug('LockUnspent()', unlock, outPoints);
    (0, validation_util_js_1.validateBoolean)(unlock, 'LockUnspent()', 'unlock');
    // validateString(outPoints, 'LockUnspent()', 'outPoints')
    const m = (0, message_util_js_1.getMessageBody)("lockunspent" /* lockunspent */, [unlock, outPoints]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // boolean value === ?
        return response;
    });
}
exports.LockUnspent = LockUnspent;
function LabelAddress(address, label) {
    console.debug('LabelAddress()', address, label);
    (0, validation_util_js_1.validateString)(address, 'LabelAddress()', 'address');
    (0, validation_util_js_1.validateString)(label, 'LabelAddress()', 'label');
    const m = (0, message_util_js_1.getMessageBody)("labeladdress" /* labeladdress */, [address, label]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // response like "Added label 'test label' to tb1qd8ap8lrzvvgw3k3wjfxcxsgz4wtspxysrs7a05",
        return response;
    });
}
exports.LabelAddress = LabelAddress;
function DropAddressLabel(address, label) {
    console.debug('DropAddressLabel()', address, label);
    (0, validation_util_js_1.validateString)(address, 'DropAddressLabel()', 'address');
    (0, validation_util_js_1.validateString)(label, 'DropAddressLabel()', 'label');
    const m = (0, message_util_js_1.getMessageBody)("dropaddresslabel" /* dropaddresslabel */, [address, label]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.DropAddressLabel = DropAddressLabel;
function GetAddressLabels() {
    console.debug('GetAddressLabels()');
    const m = (0, message_util_js_1.getMessageBody)("getaddresslabels" /* getaddresslabels */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetAddressLabels = GetAddressLabels;
function DropAddressLabels(address) {
    console.debug('DropAddressLabels()', address);
    (0, validation_util_js_1.validateString)(address, 'DropAddressLabels()', 'address');
    const m = (0, message_util_js_1.getMessageBody)("dropaddresslabels" /* dropaddresslabels */, [address]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // response like '1 label dropped'
        return response;
    });
}
exports.DropAddressLabels = DropAddressLabels;
/** DLC Message Functions */
function GetDLCHostAddress() {
    console.debug('GetDLCHostAddress()');
    const m = (0, message_util_js_1.getMessageBody)("getdlchostaddress" /* getdlchostaddress */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // response like '0:0:0:0:0:0:0:0:2862'
        return response;
    });
}
exports.GetDLCHostAddress = GetDLCHostAddress;
// payoutsVal: ContractDescriptorV0TLV / tlvPoints
function CreateContractInfo(announcementTLV, totalCollateral, payoutsVal) {
    console.debug('CreateContractInfo()');
    const m = (0, message_util_js_1.getMessageBody)("createcontractinfo" /* createcontractinfo */, [announcementTLV, totalCollateral, payoutsVal]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // on fail returns "failure"
        return response;
    });
}
exports.CreateContractInfo = CreateContractInfo;
function GetDLCs(contactAddress) {
    console.debug('GetDLCs()');
    let params = undefined;
    if (contactAddress) {
        params = [contactAddress];
    }
    const m = (0, message_util_js_1.getMessageBody)("getdlcs" /* getdlcs */, params);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetDLCs = GetDLCs;
function GetDLC(sha256hash) {
    console.debug('GetDLC()', sha256hash);
    const m = (0, message_util_js_1.getMessageBody)("getdlc" /* getdlc */, [sha256hash]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetDLC = GetDLC;
function CancelDLC(sha256hash) {
    console.debug('CancelDLC()', sha256hash);
    const m = (0, message_util_js_1.getMessageBody)("canceldlc" /* canceldlc */, [sha256hash]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // result like 'Success'
        return response;
    });
}
exports.CancelDLC = CancelDLC;
// ContractInfoV0TLV
// collateral in sats
// feeRate in sats / vbyte
function CreateDLCOffer(contractInfoTLV, collateral, feeRate, locktime, refundLT) {
    console.debug('CreateDLCOffer()', contractInfoTLV, collateral, feeRate, locktime, refundLT);
    (0, validation_util_js_1.validateString)(contractInfoTLV, 'CreateDLCOffer()', 'contractInfoTLV');
    (0, validation_util_js_1.validateNumber)(collateral, 'CreateDLCOffer()', 'collateral');
    (0, validation_util_js_1.validateNumber)(feeRate, 'CreateDLCOffer()', 'feeRate');
    (0, validation_util_js_1.validateNumber)(locktime, 'CreateDLCOffer()', 'locktime');
    (0, validation_util_js_1.validateNumber)(refundLT, 'CreateDLCOffer()', 'refundLT');
    const m = (0, message_util_js_1.getMessageBody)("createdlcoffer" /* createdlcoffer */, [contractInfoTLV, collateral, feeRate, locktime, refundLT]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.CreateDLCOffer = CreateDLCOffer;
function GetDLCOffer(temporaryContractId) {
    console.debug('GetDLCOffer()', temporaryContractId);
    (0, validation_util_js_1.validateString)(temporaryContractId, 'GetDLCOffer()', 'temporaryContractId');
    const m = (0, message_util_js_1.getMessageBody)("getdlcoffer" /* getdlcoffer */, [temporaryContractId]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // response is DLC offer message in hex
        return response;
    });
}
exports.GetDLCOffer = GetDLCOffer;
function AcceptDLCOffer(offerHex) {
    console.debug('AcceptDLCOffer()', offerHex);
    (0, validation_util_js_1.validateString)(offerHex, 'AcceptDLCOffer()', 'offerHex');
    // Flexing via UI...
    //       2021-11-22T19:09:37.173Z error: onError socket hang up
    // [HPM] Error occurred while proxying request localhost:4200 to http://localhost:9999/ [ECONNRESET] (https://nodejs.org/api/errors.html#errors_common_system_errors)
    const m = (0, message_util_js_1.getMessageBody)("acceptdlcoffer" /* acceptdlcoffer */, [offerHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // response is DLC accept message in hex
        // example numeric amount size is 86k
        return response;
    });
}
exports.AcceptDLCOffer = AcceptDLCOffer;
function AcceptDLCOfferFromFile(path, destination) {
    console.debug('AcceptDLCOfferFromFile()', path, destination);
    (0, validation_util_js_1.validateString)(path, 'AcceptDLCOfferFromFile()', 'path');
    if (destination !== undefined)
        (0, validation_util_js_1.validateString)(destination, 'AcceptDLCOfferFromFile()', 'destination');
    const args = [path];
    if (destination !== undefined)
        args.push(destination);
    const m = (0, message_util_js_1.getMessageBody)("acceptdlcofferfromfile" /* acceptdlcofferfromfile */, args);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.AcceptDLCOfferFromFile = AcceptDLCOfferFromFile;
function SignDLC(acceptHex) {
    console.debug('SignDLC()', acceptHex);
    (0, validation_util_js_1.validateString)(acceptHex, 'SignDLC()', 'acceptHex');
    const m = (0, message_util_js_1.getMessageBody)("signdlc" /* signdlc */, [acceptHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.SignDLC = SignDLC;
function SignDLCFromFile(path, destination) {
    console.debug('SignDLCFromFile()', path, destination);
    (0, validation_util_js_1.validateString)(path, 'SignDLCFromFile()', 'path');
    if (destination !== undefined)
        (0, validation_util_js_1.validateString)(destination, 'SignDLCFromFile()', 'destination');
    const args = [path];
    if (destination !== undefined)
        args.push(destination);
    const m = (0, message_util_js_1.getMessageBody)("signdlcfromfile" /* signdlcfromfile */, args);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.SignDLCFromFile = SignDLCFromFile;
function AddDLCSigs(sigsHex) {
    console.debug('AddDLCSigs()', sigsHex);
    (0, validation_util_js_1.validateString)(sigsHex, 'AddDLCSigs()', 'sigsHex');
    const m = (0, message_util_js_1.getMessageBody)("adddlcsigs" /* adddlcsigs */, [sigsHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.AddDLCSigs = AddDLCSigs;
function AddDLCSigsFromFile(path, destination) {
    console.debug('AddDLCSigsFromFile()', path, destination);
    (0, validation_util_js_1.validateString)(path, 'AddDLCSigsFromFile()', 'path');
    if (destination !== undefined)
        (0, validation_util_js_1.validateString)(destination, 'AddDLCSigsFromFile()', 'destination');
    const args = [path];
    if (destination !== undefined)
        args.push(destination);
    const m = (0, message_util_js_1.getMessageBody)("adddlcsigsfromfile" /* adddlcsigsfromfile */, args);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.AddDLCSigsFromFile = AddDLCSigsFromFile;
function AddDLCSigsAndBroadcast(sigsHex) {
    console.debug('AddDLCSigsAndBroadcast()', sigsHex);
    (0, validation_util_js_1.validateString)(sigsHex, 'AddDLCSigsAndBroadcast()', 'sigsHex');
    const m = (0, message_util_js_1.getMessageBody)("adddlcsigsandbroadcast" /* adddlcsigsandbroadcast */, [sigsHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Return is txId
        return response;
    });
}
exports.AddDLCSigsAndBroadcast = AddDLCSigsAndBroadcast;
function AddDLCSigsAndBroadcastFromFile(path, destination) {
    console.debug('AddDLCSigsAndBroadcastFromFile()', path, destination);
    (0, validation_util_js_1.validateString)(path, 'AddDLCSigsAndBroadcastFromFile()', 'path');
    if (destination !== undefined)
        (0, validation_util_js_1.validateString)(destination, 'AddDLCSigsAndBroadcastFromFile()', 'destination');
    const args = [path];
    if (destination !== undefined)
        args.push(destination);
    const m = (0, message_util_js_1.getMessageBody)("adddlcsigsandbroadcastfromfile" /* adddlcsigsandbroadcastfromfile */, args);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.AddDLCSigsAndBroadcastFromFile = AddDLCSigsAndBroadcastFromFile;
function GetDLCFundingTx(contractIdHex) {
    console.debug('GetDLCFundingTx()', contractIdHex);
    (0, validation_util_js_1.validateString)(contractIdHex, 'GetDLCFundingTx()', 'contractIdHex');
    const m = (0, message_util_js_1.getMessageBody)("getdlcfundingtx" /* getdlcfundingtx */, [contractIdHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetDLCFundingTx = GetDLCFundingTx;
function BroadcastDLCFundingTx(contractIdHex) {
    console.debug('BroadcastDLCFundingTx()', contractIdHex);
    (0, validation_util_js_1.validateString)(contractIdHex, 'GetDLCFundingTx()', 'contractIdHex');
    const m = (0, message_util_js_1.getMessageBody)("broadcastdlcfundingtx" /* broadcastdlcfundingtx */, [contractIdHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.BroadcastDLCFundingTx = BroadcastDLCFundingTx;
function ExecuteDLC(contractIdHex, oracleSigs, noBroadcast) {
    console.debug('ExecuteDLC()', contractIdHex, oracleSigs, noBroadcast);
    (0, validation_util_js_1.validateString)(contractIdHex, 'ExecuteDLC()', 'contractIdHex');
    // TODO : Validate oracleSigs
    (0, validation_util_js_1.validateBoolean)(noBroadcast, 'ExecuteDLC()', 'noBroadcast');
    const m = (0, message_util_js_1.getMessageBody)("executedlc" /* executedlc */, [contractIdHex, oracleSigs, noBroadcast]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Return is closing txId
        return response;
    });
}
exports.ExecuteDLC = ExecuteDLC;
function ExecuteDLCRefund(contractIdHex, noBroadcast) {
    console.debug('ExecuteDLCRefund()', contractIdHex);
    (0, validation_util_js_1.validateString)(contractIdHex, 'ExecuteDLC()', 'contractIdHex');
    (0, validation_util_js_1.validateBoolean)(noBroadcast, 'ExecuteDLC()', 'noBroadcast');
    const m = (0, message_util_js_1.getMessageBody)("executedlcrefund" /* executedlcrefund */, [contractIdHex, noBroadcast]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Return is txId
        return response;
    });
}
exports.ExecuteDLCRefund = ExecuteDLCRefund;
function SendToAddress(address, bitcoins, satsPerVByte, noBroadcast) {
    console.debug('SendToAddress()', address, bitcoins, satsPerVByte, noBroadcast);
    (0, validation_util_js_1.validateString)(address, 'SendToAddress()', 'address');
    (0, validation_util_js_1.validateNumber)(bitcoins, 'SendToAddress()', 'bitcoins');
    (0, validation_util_js_1.validateNumber)(satsPerVByte, 'SendToAddress()', 'satsPerVByte');
    (0, validation_util_js_1.validateBoolean)(noBroadcast, 'SendToAddress()', 'noBroadcast');
    const m = (0, message_util_js_1.getMessageBody)("sendtoaddress" /* sendtoaddress */, [address, bitcoins, satsPerVByte, noBroadcast]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Return is txId
        return response;
    });
}
exports.SendToAddress = SendToAddress;
function SendFromOutpoints(outPoints, bitcoins, satsPerVByte) {
    console.debug('SendFromOutpoints()', outPoints, bitcoins, satsPerVByte);
    // TODO : Validate outPoints[]
    (0, validation_util_js_1.validateNumber)(bitcoins, 'SendFromOutpoints()', 'bitcoins');
    (0, validation_util_js_1.validateNumber)(satsPerVByte, 'SendFromOutpoints()', 'satsPerVByte');
    const m = (0, message_util_js_1.getMessageBody)("sendfromoutpoints" /* sendfromoutpoints */, [outPoints, bitcoins, satsPerVByte]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.SendFromOutpoints = SendFromOutpoints;
function SweepWallet(address, satsPerVByte) {
    console.debug('SweepWallet()', address, satsPerVByte);
    (0, validation_util_js_1.validateString)(address, 'SweepWallet()', 'address');
    (0, validation_util_js_1.validateNumber)(satsPerVByte, 'SweepWallet()', 'satsPerVByte');
    const m = (0, message_util_js_1.getMessageBody)("dropaddresslabels" /* dropaddresslabels */, [address]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Return is txId
        return response;
    });
}
exports.SweepWallet = SweepWallet;
function SendWithAlgo(address, bitcoins, satsPerVByte, algo) {
    console.debug('SendWithAlgo()', address, bitcoins, satsPerVByte, algo);
    (0, validation_util_js_1.validateString)(address, 'SendWithAlgo()', 'address');
    (0, validation_util_js_1.validateNumber)(bitcoins, 'SendWithAlgo()', 'bitcoins');
    (0, validation_util_js_1.validateNumber)(satsPerVByte, 'SendWithAlgo()', 'satsPerVByte');
    (0, validation_util_js_1.validateString)(algo, 'SendWithAlgo()', 'algo');
    const m = (0, message_util_js_1.getMessageBody)("sendwithalgo" /* sendwithalgo */, [address, bitcoins, satsPerVByte, algo]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.SendWithAlgo = SendWithAlgo;
function SignPSBT(hexOrBase64) {
    console.debug('SignPSBT()', hexOrBase64);
    (0, validation_util_js_1.validateString)(hexOrBase64, 'SignPSBT()', 'hexOrBase64');
    const m = (0, message_util_js_1.getMessageBody)("signpsbt" /* signpsbt */, [hexOrBase64]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.SignPSBT = SignPSBT;
function OpReturnCommit(message, hashMessage, satsPerVByte) {
    console.debug('OpReturnCommit()', message, hashMessage, satsPerVByte);
    (0, validation_util_js_1.validateString)(message, 'OpReturnCommit()', 'message');
    (0, validation_util_js_1.validateBoolean)(hashMessage, 'OpReturnCommit()', 'hashMessage');
    (0, validation_util_js_1.validateNumber)(satsPerVByte, 'OpReturnCommit()', 'satsPerVByte');
    const m = (0, message_util_js_1.getMessageBody)("opreturncommit" /* opreturncommit */, [message, hashMessage, satsPerVByte]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.OpReturnCommit = OpReturnCommit;
function BumpFeeRBF(sha256hash, satsPerVByte) {
    console.debug('BumpFeeRBF()', sha256hash, satsPerVByte);
    (0, validation_util_js_1.validateString)(sha256hash, 'BumpFeeRBF()', 'sha256hash');
    (0, validation_util_js_1.validateNumber)(satsPerVByte, 'BumpFeeRBF()', 'satsPerVByte');
    const m = (0, message_util_js_1.getMessageBody)("bumpfeerbf" /* bumpfeerbf */, [sha256hash, satsPerVByte]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.BumpFeeRBF = BumpFeeRBF;
function BumpFeeCPFP(sha256hash, satsPerVByte) {
    console.debug('BumpFeeCPFP()', sha256hash, satsPerVByte);
    (0, validation_util_js_1.validateString)(sha256hash, 'BumpFeeCPFP()', 'sha256hash');
    (0, validation_util_js_1.validateNumber)(satsPerVByte, 'BumpFeeCPFP()', 'satsPerVByte');
    const m = (0, message_util_js_1.getMessageBody)("bumpfeecpfp" /* bumpfeecpfp */, [sha256hash, satsPerVByte]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.BumpFeeCPFP = BumpFeeCPFP;
function Rescan(batchSize, start, end, force, ignoreCreationTime) {
    console.debug('Rescan()', batchSize, start, end, force, ignoreCreationTime);
    if (batchSize !== null)
        (0, validation_util_js_1.validateNumber)(batchSize, 'Rescan()', 'batchSize');
    if (start !== null)
        (0, validation_util_js_1.validateNumber)(start, 'Rescan()', 'start');
    if (end !== null)
        (0, validation_util_js_1.validateNumber)(end, 'Rescan()', 'end');
    (0, validation_util_js_1.validateBoolean)(force, 'Rescan()', 'force');
    (0, validation_util_js_1.validateBoolean)(ignoreCreationTime, 'Rescan()', 'ignoreCreationTime');
    const m = (0, message_util_js_1.getMessageBody)("rescan" /* rescan */, [batchSize, start, end, force, ignoreCreationTime]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // result like "Rescan started."
        return response;
    });
}
exports.Rescan = Rescan;
function GetUTXOs() {
    console.debug('GetUTXOs()');
    const m = (0, message_util_js_1.getMessageBody)("getutxos" /* getutxos */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetUTXOs = GetUTXOs;
function ListReservedUTXOs() {
    console.debug('ListReservedUTXOs()');
    const m = (0, message_util_js_1.getMessageBody)("listreservedutxos" /* listreservedutxos */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.ListReservedUTXOs = ListReservedUTXOs;
function GetAddresses() {
    console.debug('GetAddresses()');
    const m = (0, message_util_js_1.getMessageBody)("getaddresses" /* getaddresses */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetAddresses = GetAddresses;
function GetSpentAddresses() {
    console.debug('GetSpentAddresses()');
    const m = (0, message_util_js_1.getMessageBody)("getspentaddresses" /* getspentaddresses */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetSpentAddresses = GetSpentAddresses;
function GetFundedAddresses() {
    console.debug('GetFundedAddresses()');
    const m = (0, message_util_js_1.getMessageBody)("getfundedaddresses" /* getfundedaddresses */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetFundedAddresses = GetFundedAddresses;
function GetUnusedAddresses() {
    console.debug('GetUnusedAddresses()');
    const m = (0, message_util_js_1.getMessageBody)("getunusedaddresses" /* getunusedaddresses */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetUnusedAddresses = GetUnusedAddresses;
function GetAccounts() {
    console.debug('GetAccounts()');
    const m = (0, message_util_js_1.getMessageBody)("getaccounts" /* getaccounts */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // response like ['tpub...','vpub...','upub...']
        return response;
    });
}
exports.GetAccounts = GetAccounts;
function GetAddressInfo(address) {
    console.debug('GetAddressInfo()', address);
    const m = (0, message_util_js_1.getMessageBody)("getaddressinfo" /* getaddressinfo */, [address]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetAddressInfo = GetAddressInfo;
// THIS IS UNTESTED
function CreateNewAccount() {
    console.debug('CreateNewAccount()');
    const m = (0, message_util_js_1.getMessageBody)("createnewaccount" /* createnewaccount */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // response like 
        return response;
    });
}
exports.CreateNewAccount = CreateNewAccount;
// keymanagerpassphrasechange
// keymanagerpassphraseset
function ImportSeed(walletName, mnemonic, passphrase) {
    console.debug('ImportSeed()', walletName); // not logging mnemonic, passphrase
    (0, validation_util_js_1.validateString)(walletName, 'ImportSeed()', 'walletName');
    (0, validation_util_js_1.validateString)(mnemonic, 'ImportSeed()', 'mnemonic');
    if (passphrase !== undefined)
        (0, validation_util_js_1.validateString)(passphrase, 'ImportSeed()', 'passphrase');
    const m = (0, message_util_js_1.getMessageBody)("importseed" /* importseed */, [walletName, mnemonic, passphrase]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.ImportSeed = ImportSeed;
function ImportXprv(walletName, mnemonic, passphrase) {
    console.debug('ImportXprv()', walletName); // not logging mnemonic, passphrase
    (0, validation_util_js_1.validateString)(walletName, 'ImportXprv()', 'walletName');
    (0, validation_util_js_1.validateString)(mnemonic, 'ImportXprv()', 'mnemonic');
    if (passphrase !== undefined)
        (0, validation_util_js_1.validateString)(passphrase, 'ImportXprv()', 'passphrase');
    const m = (0, message_util_js_1.getMessageBody)("importxprv" /* importxprv */, [walletName, mnemonic, passphrase]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.ImportXprv = ImportXprv;
function SendRawTransaction(hex) {
    console.debug('SendRawTransaction()', hex);
    (0, validation_util_js_1.validateString)(hex, 'SendRawTransaction()', 'hex');
    const m = (0, message_util_js_1.getMessageBody)("sendrawtransaction" /* sendrawtransaction */, [hex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Returns txId
        return response;
    });
}
exports.SendRawTransaction = SendRawTransaction;
function EstimateFee() {
    console.debug('EstimateFee()');
    const m = (0, message_util_js_1.getMessageBody)("estimatefee" /* estimatefee */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // response like 1, -1 is 'unknown'/'not set'
        return response;
    });
}
exports.EstimateFee = EstimateFee;
function GetDLCWalletAccounting() {
    console.debug('GetDLCWalletAccounting()');
    const m = (0, message_util_js_1.getMessageBody)("getdlcwalletaccounting" /* getdlcwalletaccounting */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.GetDLCWalletAccounting = GetDLCWalletAccounting;
// Do we want to support getting this back as a json payload?
function BackupWallet(path) {
    console.debug('BackupWallet()', path);
    (0, validation_util_js_1.validateString)(path, 'BackupWallet()', 'path');
    const m = (0, message_util_js_1.getMessageBody)("backupwallet" /* backupwallet */, [path]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // result: 'done'
        return response;
    });
}
exports.BackupWallet = BackupWallet;
/** Core Route Functions */
function FinalizePSBT() {
    console.debug('FinalizePSBT()');
    const m = (0, message_util_js_1.getMessageBody)("finalizepsbt" /* finalizepsbt */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.FinalizePSBT = FinalizePSBT;
function ExtractFromPSBT() {
    console.debug('ExtractFromPSBT()');
    const m = (0, message_util_js_1.getMessageBody)("extractfrompsbt" /* extractfrompsbt */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.ExtractFromPSBT = ExtractFromPSBT;
function ConvertToPSBT() {
    console.debug('ConvertToPSBT()');
    const m = (0, message_util_js_1.getMessageBody)("converttopsbt" /* converttopsbt */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.ConvertToPSBT = ConvertToPSBT;
function CombinePSBT() {
    console.debug('CombinePSBT()');
    const m = (0, message_util_js_1.getMessageBody)("combinepsbts" /* combinepsbts */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.CombinePSBT = CombinePSBT;
function JoinPSBTs() {
    console.debug('JoinPSBTs()');
    const m = (0, message_util_js_1.getMessageBody)("joinpsbts" /* joinpsbts */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.JoinPSBTs = JoinPSBTs;
function DecodePSBT() {
    console.debug('DecodePSBT()');
    const m = (0, message_util_js_1.getMessageBody)("decodepsbt" /* decodepsbt */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.DecodePSBT = DecodePSBT;
function DecodeRawTransaction() {
    console.debug('DecodeRawTransaction()');
    const m = (0, message_util_js_1.getMessageBody)("decoderawtransaction" /* decoderawtransaction */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.DecodeRawTransaction = DecodeRawTransaction;
function AnalyzePSBT() {
    console.debug('AnalyzePSBT()');
    const m = (0, message_util_js_1.getMessageBody)("analyzepsbt" /* analyzepsbt */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.AnalyzePSBT = AnalyzePSBT;
function DecodeSign(signedHex) {
    console.debug('DecodeSign()', signedHex);
    (0, validation_util_js_1.validateString)(signedHex, 'DecodeSign()', 'signedHex');
    const m = (0, message_util_js_1.getMessageBody)("decodesign" /* decodesign */, [signedHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.DecodeSign = DecodeSign;
function DecodeAccept(acceptHex) {
    console.debug('DecodeAccept()', acceptHex);
    (0, validation_util_js_1.validateString)(acceptHex, 'DecodeAccept()', 'acceptHex');
    const m = (0, message_util_js_1.getMessageBody)("decodeaccept" /* decodeaccept */, [acceptHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.DecodeAccept = DecodeAccept;
function DecodeOffer(offerHex) {
    console.debug('DecodeOffer()', offerHex);
    (0, validation_util_js_1.validateString)(offerHex, 'DecodeOffer()', 'offerHex');
    const m = (0, message_util_js_1.getMessageBody)("decodeoffer" /* decodeoffer */, [offerHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.DecodeOffer = DecodeOffer;
function DecodeContractInfo(contractInfoHex) {
    console.debug('DecodeContractInfo()', contractInfoHex);
    (0, validation_util_js_1.validateString)(contractInfoHex, 'DecodeContractInfo()', 'contractInfoHex');
    const m = (0, message_util_js_1.getMessageBody)("decodecontractinfo" /* decodecontractinfo */, [contractInfoHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.DecodeContractInfo = DecodeContractInfo;
function DecodeAnnouncement(announcementHex) {
    console.debug('DecodeAnnouncement()', announcementHex);
    (0, validation_util_js_1.validateString)(announcementHex, 'DecodeAnnouncement()', 'announcementHex');
    const m = (0, message_util_js_1.getMessageBody)("decodeannouncement" /* decodeannouncement */, [announcementHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.DecodeAnnouncement = DecodeAnnouncement;
// 'failure' on error
function DecodeAttestments(attestmentHex) {
    console.debug('DecodeAttestments()', attestmentHex);
    (0, validation_util_js_1.validateString)(attestmentHex, 'DecodeAttestments()', 'attestmentHex');
    const m = (0, message_util_js_1.getMessageBody)("decodeattestments" /* decodeattestments */, [attestmentHex]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.DecodeAttestments = DecodeAttestments;
function CreateMultiSig() {
    console.debug('CreateMultiSig()');
    const m = (0, message_util_js_1.getMessageBody)("createmultisig" /* createmultisig */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.CreateMultiSig = CreateMultiSig;
/** Offers */
function OfferList() {
    console.debug('OfferList()');
    const m = (0, message_util_js_1.getMessageBody)("offers-list" /* offerslist */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.OfferList = OfferList;
function OfferAdd(offerTLV, peer, message) {
    console.debug('OfferAdd()', peer, message);
    (0, validation_util_js_1.validateString)(offerTLV, 'OfferAdd()', 'offerTLV');
    (0, validation_util_js_1.validateString)(peer, 'OfferAdd()', 'peer');
    (0, validation_util_js_1.validateString)(message, 'OfferAdd()', 'message');
    const m = (0, message_util_js_1.getMessageBody)("offer-add" /* offeradd */, [offerTLV, peer, message]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Returns hash.hex
        return response;
    });
}
exports.OfferAdd = OfferAdd;
function OfferRemove(hash) {
    console.debug('OfferRemove()', hash);
    (0, validation_util_js_1.validateString)(hash, 'OfferRemove()', 'hash');
    const m = (0, message_util_js_1.getMessageBody)("offer-remove" /* offerremove */, [hash]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Returns hash.hex
        return response;
    });
}
exports.OfferRemove = OfferRemove;
/** Contacts */
function ContactList() {
    console.debug('ContactList()');
    const m = (0, message_util_js_1.getMessageBody)("contacts-list" /* contactslist */);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        return response;
    });
}
exports.ContactList = ContactList;
function ContactAdd(alias, address, memo) {
    console.debug('ContactAdd()', alias, address, memo);
    (0, validation_util_js_1.validateString)(alias, 'ContactAdd()', 'alias');
    (0, validation_util_js_1.validateString)(address, 'ContactAdd()', 'address');
    (0, validation_util_js_1.validateString)(memo, 'ContactAdd()', 'memo');
    const m = (0, message_util_js_1.getMessageBody)("contact-add" /* contactadd */, [alias, address, memo]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Returns "ok"
        return response;
    });
}
exports.ContactAdd = ContactAdd;
function ContactRemove(address) {
    console.debug('ContactRemove()', address);
    (0, validation_util_js_1.validateString)(address, 'ContactRemove()', 'address');
    const m = (0, message_util_js_1.getMessageBody)("contact-remove" /* contactremove */, [address]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Returns "ok"
        return response;
    });
}
exports.ContactRemove = ContactRemove;
function DLCContactAdd(dlcId, address) {
    console.debug('DLCContactAdd()', dlcId, address);
    (0, validation_util_js_1.validateString)(dlcId, 'DLCContactAdd()', 'dlcId');
    (0, validation_util_js_1.validateString)(address, 'DLCContactAdd()', 'address');
    const m = (0, message_util_js_1.getMessageBody)("dlc-contact-add" /* dlccontactadd */, [dlcId, address]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Returns "ok"
        return response;
    });
}
exports.DLCContactAdd = DLCContactAdd;
function DLCContactRemove(dlcId) {
    console.debug('DLCContactRemove()', dlcId);
    (0, validation_util_js_1.validateString)(dlcId, 'DLCContactRemove()', 'dlcId');
    const m = (0, message_util_js_1.getMessageBody)("dlc-contact-remove" /* dlccontactremove */, [dlcId]);
    return (0, index_js_1.SendServerMessage)(m).then(response => {
        // Returns "ok"
        return response;
    });
}
exports.DLCContactRemove = DLCContactRemove;
//# sourceMappingURL=index.js.map