"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.runTests = void 0;
const WalletServer = __importStar(require("./index"));
const basic_tests_1 = require("./test/basic-tests");
const blockchain_tests_1 = require("./test/blockchain-tests");
const core_tests_1 = require("./test/core-tests");
const dlc_tests_1 = require("./test/dlc-tests");
const network_tests_1 = require("./test/network-tests");
console.debug('tests.ts');
WalletServer.ConfigureServerURL('http://localhost:9999/');
WalletServer.ConfigureAuthorizationHeader('Basic ' + Buffer.from('bitcoins:password').toString('base64'));
function runTests() {
    return __awaiter(this, void 0, void 0, function* () {
        yield (0, blockchain_tests_1.blockchainTests)();
        yield (0, core_tests_1.coreTests)();
        yield (0, network_tests_1.networkTests)();
        yield (0, dlc_tests_1.dlcTests)();
        yield (0, basic_tests_1.basicTests)();
    });
}
exports.runTests = runTests;
runTests();
//# sourceMappingURL=tests.js.map