var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import * as WalletServer from './index';
import { basicTests } from './test/basic-tests';
import { blockchainTests } from './test/blockchain-tests';
import { coreTests } from './test/core-tests';
import { dlcTests } from './test/dlc-tests';
import { networkTests } from './test/network-tests';
console.debug('tests.ts');
WalletServer.ConfigureServerURL('http://localhost:9999/');
WalletServer.ConfigureAuthorizationHeader('Basic ' + Buffer.from('bitcoins:password').toString('base64'));
export function runTests() {
    return __awaiter(this, void 0, void 0, function* () {
        yield blockchainTests();
        yield coreTests();
        yield networkTests();
        yield dlcTests();
        yield basicTests();
    });
}
runTests();
//# sourceMappingURL=tests.js.map