export declare const enum WalletMessageType {
    getversion = "getversion",
    isempty = "isempty",
    walletinfo = "walletinfo",
    getbalance = "getbalance",
    getconfirmedbalance = "getconfirmedbalance",
    getunconfirmedbalance = "getunconfirmedbalance",
    getbalances = "getbalances",
    getnewaddress = "getnewaddress",
    gettransaction = "gettransaction",
    lockunspent = "lockunspent",
    labeladdress = "labeladdress",
    dropaddresslabel = "dropaddresslabel",
    getaddresslabels = "getaddresslabels",
    dropaddresslabels = "dropaddresslabels",
    getdlcs = "getdlcs",
    getdlc = "getdlc",
    canceldlc = "canceldlc",
    createdlcoffer = "createdlcoffer",
    getdlcoffer = "getdlcoffer",
    acceptdlcoffer = "acceptdlcoffer",
    acceptdlcofferfromfile = "acceptdlcofferfromfile",
    signdlc = "signdlc",
    signdlcfromfile = "signdlcfromfile",
    adddlcsigs = "adddlcsigs",
    adddlcsigsfromfile = "adddlcsigsfromfile",
    adddlcsigsandbroadcast = "adddlcsigsandbroadcast",
    adddlcsigsandbroadcastfromfile = "adddlcsigsandbroadcastfromfile",
    getdlcfundingtx = "getdlcfundingtx",
    broadcastdlcfundingtx = "broadcastdlcfundingtx",
    executedlc = "executedlc",
    executedlcrefund = "executedlcrefund",
    sendtoaddress = "sendtoaddress",
    sendfromoutpoints = "sendfromoutpoints",
    sweepwallet = "sweepwallet",
    sendwithalgo = "sendwithalgo",
    signpsbt = "signpsbt",
    opreturncommit = "opreturncommit",
    bumpfeerbf = "bumpfeerbf",
    bumpfeecpfp = "bumpfeecpfp",
    rescan = "rescan",
    getutxos = "getutxos",
    listreservedutxos = "listreservedutxos",
    getaddresses = "getaddresses",
    getspentaddresses = "getspentaddresses",
    getfundedaddresses = "getfundedaddresses",
    getunusedaddresses = "getunusedaddresses",
    getaccounts = "getaccounts",
    getaddressinfo = "getaddressinfo",
    createnewaccount = "createnewaccount",
    importseed = "importseed",
    importxprv = "importxprv",
    sendrawtransaction = "sendrawtransaction",
    estimatefee = "estimatefee",
    getdlcwalletaccounting = "getdlcwalletaccounting",
    backupwallet = "backupwallet",
    offeradd = "offer-add",
    offerremove = "offer-remove",
    offerslist = "offers-list",
    offersend = "offer-send",
    contactadd = "contact-add",
    contactremove = "contact-remove",
    contactslist = "contacts-list",
    dlccontactadd = "dlc-contact-add",
    dlccontactremove = "dlc-contact-remove"
}
export interface WalletInfo {
    wallet: Wallet;
}
export interface Wallet {
    keymanager: any;
    walletName: string;
    xpub: string;
    hdPath: string;
    height: number;
    blockHash: string;
}
export interface Balances {
    confirmed: number;
    unconfirmed: number;
    reserved: number;
    total: number;
}
export interface UTXO {
    outpoint: Outpoint;
    value: number;
}
export interface Outpoint {
    txid: string;
    vout: number;
}
export interface FundedAddress {
    address: string;
    value: number;
}
export interface AddressInfo {
    pubkey: string;
    path: string;
}
export interface DLCWalletAccounting {
    myCollateral: number;
    theirCollateral: number;
    myPayout: number;
    theirPayout: number;
    pnl: number;
    rateOfReturn: number;
}
export interface DLCContract {
    peer: string;
    contractInfo: string;
    contractMaturity: number;
    contractTimeout: number;
    dlcId: string;
    feeRate: number;
    isInitiator: boolean;
    lastUpdated: string;
    localCollateral: number;
    remoteCollateral: number;
    state: string;
    temporaryContractId: string;
    totalCollateral: number;
    payoutAddress: {
        address: string;
        isExternal: boolean;
    };
    contractId?: string;
    fundingTxId?: string;
    closingTxId?: string;
    counterPartyPayout?: number;
    myPayout?: number;
    oracleSigs?: string[];
    oracles?: string[];
    outcomes?: string | number[][];
    pnl?: number;
    rateOfReturn?: number;
}
export declare enum DLCState {
    offered = "Offered",
    accepting = "AcceptedComputingAdaptorSigs",
    accepted = "Accepted",
    signing = "SignComputingAdaptorSigs",
    signed = "Signed",
    broadcast = "Broadcasted",
    confirmed = "Confirmed",
    claimed = "Claimed",
    remoteClaimed = "RemoteClaimed",
    refunded = "Refunded"
}
export interface IncomingOffer {
    hash: string;
    receivedAt: number;
    peer: string;
    message: string;
    offerTLV: string;
}
export interface Contact {
    alias: string;
    address: string;
    memo: string;
}
//# sourceMappingURL=wallet-types.d.ts.map